
#include <iostream>
#include <sstream>
#include <string>
#include <vector>

using namespace std;


typedef unsigned long long Uint;
typedef signed long long Sint;

typedef Uint TCash;

struct bank
{
	string name;
	TCash money;
};

/*
#define alter(what) ((TCash) (what*100))
/*/
#define alter(what) ((TCash) what)
//*/

Uint Convert(string &str)
{
	for(Uint i = 0; str[i] != 0; i++)
	{
		if(str[i] == '.')
			str[i] = ' ';
	}
	
	istringstream iss;
	iss.str(str);
	
	Uint big, small;
	iss >> big >> small;
	
	return (big*100)+small;
}

/*
#define DEBUG(str) cout << str
/*/
#define DEBUG(str) (void(0))
//*/
int main()
{
	while(true)
	{
		vector<bank> banks;		
		
		Sint num;
		cin >> num;
		
		if(!num)
			break;
		
		
		for(Sint i = 0; i < num; i++)
		{
			bank new_bank;
			string money;
			
			cin >> new_bank.name;
			cin >> money;
			
			new_bank.money = Convert(money);
			banks.push_back(new_bank);
		}
		
		string str;
		
		
		while(true)
		{
			
			
			cin >> str;
			
			if(str == "end")
			{
				cout << "end" << endl << endl;
				break;
			}
			else
			if(str == "withdraw")
			{
				cout << "withdraw ";
				string bank_name;
				string s_money;
				TCash d_money;
				
				cin >> bank_name;
				cin >> s_money;
				
				cout << s_money << ": ";
				d_money = Convert(s_money);
				
				DEBUG("<" << d_money << ">");
				
				bool founded = false;
				
				for(Uint i = 0; i < banks.size(); i++)
				{
					bank &w_bank = banks.at(i);
					
					if(w_bank.name == bank_name)
					{
						founded = true;
						
						if(d_money > w_bank.money)
						{
							cout << "insufficient funds";
						}
						else
						{
							w_bank.money -= d_money;
							cout << "ok";
							DEBUG(" " << w_bank.money);
						}
						
						break;
					}
				}
				
				if(!founded)
					cout << "no such account";
			}
			else
			if(str == "deposit")
			{
				string bank_name;
				string str_money;
				TCash money;
				
				cin >> bank_name;
				cin >> str_money;
				
				cout << "deposit " << str_money << ": ";
				
				money = Convert(str_money);
				
				bool founded = false;
				
				for(Uint i = 0; i < banks.size(); i++)
				{
					bank &w_bank = banks.at(i);
					
					if(w_bank.name == bank_name)
					{
						founded = true;
						
						w_bank.money += money;
						cout << "ok";
						DEBUG(" " << w_bank.money);
						
						break;
					}
				}
				
				if(!founded)
					cout << "no such account";
			}
			else
			if(str == "transfer")
			{
				string bank_name_1, bank_name_2;
				string str_money;
				TCash money;
				
				bank *bank1 = NULL;
				bank *bank2 = NULL;
				
				cin >> bank_name_1 >> bank_name_2 >> str_money;
				
				cout << "transfer " << str_money << ": ";
				
				money = Convert(str_money);
				
				if(bank_name_1 == bank_name_2)
				{
					cout << "same account";
				}
				else
				{
					bool founded1 = false;
					bool founded2 = false;
					
					for(Uint i = 0; (i < banks.size()); i++)
					{
						bank &work_bank = banks.at(i);
						
						if(work_bank.name == bank_name_1)
						{
							bank1 = &work_bank;
							founded1 = true;
						}
						
						if(work_bank.name == bank_name_2)
						{
							bank2 = &work_bank;
							founded2 = true;
						}
						
						if(founded1 && founded2)
							break;
					}
					
					if(founded1 && founded2)
					{
						if(bank1->money < money)
						{
							cout << "insufficient funds";
						}
						else
						{
							bank1->money -= money;
							bank2->money += money;
							DEBUG(" " << bank1->money);
							DEBUG(" " << bank2->money);
							if(bank_name_1[5] == bank_name_2[5])
								cout << "ok";
							else
								cout << "interbank";
						} 
					}
					else
					{
						cout << "no such account";
					}
				}
			}
			else
			if(str == "create")
			{
				string new_bank_name;
				cin >> new_bank_name;
				
				cout << "create: ";
				
				bool founded = false;
				
				for(Uint i = 0; i < banks.size(); i++)
				{
					//if(banks.at(i).name == new_bank_name)
					string str1, str2;
					
					for(int k = 0; k < 4; k++)
					{
						str1 += banks.at(i).name[k];
						str2 += new_bank_name[k];
					}
					
					if(str1 == str2)
					{
						founded = true;
						cout << "already exists";
						break;
					}
				}
				
				if(!founded)
				{
					bank new_bank;
					new_bank.name = new_bank_name;
					new_bank.money = 0;
					banks.push_back(new_bank);
					cout << "ok";
				}
			}
			
			cout << endl;
		}
		
		
		
		banks.clear();
	}
	
	cout << "goodbye" << endl;
	
	return 0;
}
